﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace Inverted_DataView_Rowfilter
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
           // TODO: This line of code loads data into the 'c1NWINDDataSet.Employees' table. You can move, or remove it, as needed.
            this.employeesTableAdapter.Fill(this.c1NWINDDataSet.Employees);

            c1TrueDBGrid1.DataSource = c1NWINDDataSet.Employees.DefaultView;

           // we'll do the filtering ourselves
            this.c1TrueDBGrid1.AllowFilter = false;
            int x= 10, y=20;
            TextBox tb;
            Label l;
            for (int i = 0; i < c1TrueDBGrid1.Splits[0].DisplayColumns.Count; i++)
            {
                l = new Label();
                tb = new TextBox();
                tb.TextChanged +=new EventHandler(tb_TextChanged);
                l.Text = c1TrueDBGrid1.Splits[0].DisplayColumns[i].Name;
                l.Location = new Point(x,y);
                tb.Location = new Point(l.Size.Width+10,y);
                splitter1.Controls.AddRange(new Control[] { l, tb });
                y += 25;
            }
        }

        private void tb_TextChanged(object sender,EventArgs e)
        {
            string filter_text = ((TextBox)sender).Text;
            int index;
            // build our filter expression
            StringBuilder sb = new StringBuilder();
            foreach (Control c in splitter1.Controls)
            {
                if (((TextBox)sender) == c)
                {
                    index = splitter1.Controls.IndexOf(c);
                    foreach (C1.Win.C1TrueDBGrid.C1DataColumn dc in this.c1TrueDBGrid1.Columns)
                    {
                        if (filter_text.Length > 0 && dc.DataField == splitter1.Controls[index - 1].Text)
                        {
                            if (sb.Length > 0) sb.Append(" AND ");
                            if (dc.DataType == Type.GetType("System.Int32"))
                                sb.Append(dc.DataField + " = " + filter_text );
                            else
                                sb.Append(dc.DataField + " like " + "'" + filter_text + "*'");
                        }
                    }
                }
            }
            
            // filter the data in the Grid
            c1NWINDDataSet.Employees.DefaultView.RowFilter = sb.ToString();
        }
    }
}
